package com.tzld.longarticle.recommend.server.service.rank;


import com.tzld.longarticle.recommend.server.service.ServiceBeanFactory;
import com.tzld.longarticle.recommend.server.service.rank.strategy.DefaultRankStrategy;
import com.tzld.longarticle.recommend.server.service.rank.strategy.RankV2Strategy;
import com.tzld.longarticle.recommend.server.service.rank.strategy.RankV3Strategy;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @author dyp
 */
@Service
@Slf4j
public class RankService {

    public RankResult rank(RankParam param) {
        RankStrategy strategy = getRankStrategy(param);
        return strategy.rank(param);
    }

    private RankStrategy getRankStrategy(RankParam param) {
        switch (param.getStrategy()) {
            case "ArticleRankV2":
                return ServiceBeanFactory.getBean(RankV2Strategy.class);
            case "ArticleRankV3":
                return ServiceBeanFactory.getBean(RankV3Strategy.class);
            default:
                return ServiceBeanFactory.getBean(DefaultRankStrategy.class);
        }
    }


}
